#pragma once

namespace saw {
template<typename Codec, typename Schema> class Rpc;

/**
 * Provides the interface for messages with an rpc type behaviour
 */
template<typename Codec, typename... Responses, typename... Requests, StringLiteral... Literals>
class Rpc<schema::Interface<schema::Function<Responses, Requests, Literals>...>> {
public:

    class Client {
    public:
        /**
         * 
         */
        template<StringLiteral FunctionLiteral>
        Conveyor<Message<FunctionResponse>> request(Message<FunctionRequest> parameters);
    };

    class Service {
    public:
        /**
         * 
         */
        template<StringLiteral FunctionLiteral>
        Conveyor<Message<FunctionResponse>> handle(Message<FunctionRequest> request);
    };

    class Server {

    };
};
}
